/*
 *
 * Copyright 1999, Cadence Design Systems, Incorporated.
 *
 * Cadence Design Systems (Cadence) and the author hereby disclaim
 * all implied warranties, including the implied warranties of merchant-
 * ability and fitness for a particular purpose. Cadence is not liable for
 * any damages incurred by the use of this software and/or documentation,
 * including direct, indirect, special, incidental, or consequential
 * damages.
 *
 * Cadence grants the bearer the right to modify, copy, and redistribute
 * this software and documentation, but requests that Cadence be acknowledged
 * for its contribution in the resulting product.
 *
 */

import javax.swing.*;
import java.awt.*;
import javax.swing.JDialog;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

/**
 * s2iAudit implements a window that parses a Spice file and warns of questionable
 * content. The user may edit and reparse the Spice file. When finished,
 * the s2iProjectSetup window is invoked.
 *
 * @author Anish Malhotra, Cadence Design Systems
 */

public class s2iAudit extends javax.swing.JDialog
{

/**
 * Construct a window that parses a Spice file and warns of questionable
 * content. The user may edit and reparse the Spice file. When finished,
 * the s2iProjectSetup window is invoked.
 *
 * @author Anish Malhotra, Cadence Design Systems
 */

	public s2iAudit()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setModal(true);
		getContentPane().setLayout(new BorderLayout(0,0));
		setVisible(false);
		setSize(499,304);
		jPanel1 = new javax.swing.JPanel();
		jPanel1.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		jPanel1.setBounds(0,269,499,35);
		jPanel1.setFont(new Font("Dialog", Font.PLAIN, 12));
		jPanel1.setForeground(new Color(0));
		jPanel1.setBackground(new Color(-3355444));
		getContentPane().add("South", jPanel1);
		jEdit = new javax.swing.JButton();
		jEdit.setText("Edit SPICE");
		jEdit.setActionCommand("Edit SPICE");
		jEdit.setSelected(true);
		jEdit.setToolTipText("Brings up an Editor");
		jEdit.setBounds(19,5,95,25);
		jEdit.setFont(new Font("Dialog", Font.PLAIN, 12));
		jEdit.setForeground(new Color(0));
		jEdit.setBackground(new Color(-3355444));
		jPanel1.add(jEdit);
		jCancel = new javax.swing.JButton();
		jCancel.setText("  Cancel  ");
		jCancel.setActionCommand("  Cancel  ");
		jCancel.setBounds(119,5,85,25);
		jCancel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jCancel.setForeground(new Color(0));
		jCancel.setBackground(new Color(-3355444));
		jPanel1.add(jCancel);
		jReparse = new javax.swing.JButton();
		jReparse.setText(" Reparse  ");
		jReparse.setActionCommand(" Reparse  ");
		jReparse.setToolTipText("This again audits the SPICE File");
		jReparse.setBounds(209,5,91,25);
		jReparse.setFont(new Font("Dialog", Font.PLAIN, 12));
		jReparse.setForeground(new Color(0));
		jReparse.setBackground(new Color(-3355444));
		jPanel1.add(jReparse);
		jCont = new javax.swing.JButton();
		jCont.setText(" Continue ");
		jCont.setActionCommand(" Continue ");
		jCont.setToolTipText("Contnue, despite the Errors/Warnings");
		jCont.setBounds(305,5,91,25);
		jCont.setFont(new Font("Dialog", Font.PLAIN, 12));
		jCont.setForeground(new Color(0));
		jCont.setBackground(new Color(-3355444));
		jPanel1.add(jCont);
		jScrollPane1 = new javax.swing.JScrollPane();
		jScrollPane1.setOpaque(true);
		jScrollPane1.setBounds(0,0,499,269);
		jScrollPane1.setFont(new Font("Dialog", Font.PLAIN, 12));
		jScrollPane1.setForeground(new Color(0));
		jScrollPane1.setBackground(new Color(-3355444));
		getContentPane().add("Center", jScrollPane1);
		jTextArea = new javax.swing.JTextArea();
		jTextArea.setMargin(new java.awt.Insets(0,0,0,0));
		jTextArea.setLineWrap(true);
		jTextArea.setBounds(0,0,20,40);
		jTextArea.setFont(new Font("Monospaced", Font.PLAIN, 12));
		jTextArea.setForeground(new Color(0));
		jTextArea.setBackground(new Color(16777215));
		jScrollPane1.getViewport().add(jTextArea);
		//}}

		//{{ User's init Controls
		// anish - 02 Dec 98
		jTextArea.setEditable(false);
		//}}
		

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		jEdit.addActionListener(lSymAction);
		jCancel.addActionListener(lSymAction);
		jReparse.addActionListener(lSymAction);
		jCont.addActionListener(lSymAction);
		//}}
	}

 /**
 * Construct a window that parses a Spice file and warns of questionable
 * content. The user may edit and reparse the Spice file. When finished,
 * the s2iProjectSetup window is invoked.
 *
 * @param sTitle The window title String
 */

	public s2iAudit(String sTitle)
	{
		this();
		setTitle(sTitle);
	}

/**
  * Show the window. This resets the window location before calling the
  * superclass.
 *
 * @param b true or false for visibility.
 */
	public void setVisible(boolean b)
	{
		if (b)
			setLocation(50, 50);
		super.setVisible(b);
	}

	/**
 * Test the window. No Spice data is parsed.
 *
 * @param args unused
 */

 static public void main(String args[])
	{
		(new s2iAudit()).setVisible(true);
	}

 /**
 * Call the superclass addNotify(), then readjust the layout.
 */

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;
		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + d.width,
            getInsets().top + getInsets().bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JPanel jPanel1;
	javax.swing.JButton jEdit;
	javax.swing.JButton jCancel;
	javax.swing.JButton jReparse;
	javax.swing.JButton jCont;
	javax.swing.JScrollPane jScrollPane1;
	javax.swing.JTextArea jTextArea;
	//}}

    //{{ Non Symantec controls declaration
	// anish 2 Dec 98
	String cmdValue = null;
	String editFileName = null;
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == s2iAudit.this)
				JDialog1_WindowClosing(event);
		}
	}

 /**
 * Quit the application when the window closes.
 *
 * @param event The event causing the window to close.
 */

	void JDialog1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false); // hide the Frame
		dispose();	     // free the system resources
		System.exit(0);    // close the application
	}

	//{{ Non -symantec code
 /**
 * Append text to the Audit text area.
 *
 * @param str The text string to append.
 */

	// anish - 01 Dec 98
	void addText(String str)
	{
	    jTextArea.append(str);
	}

 /**
 * Append text to the Audit text area.
 *
 * @param str The text string to append.
 */

	String getValue()
	{
	    return(cmdValue);
	}

 /**
 * Set the path of the Spice file to be audited.
 *
 * @param name The path of the Spice file to be audited.
 */

	void setFileName(String name)
	{
	    editFileName = name;
	}

 /**
 * Clear all text in the window.
 */

	//anish - 02 Dec 98
	void clearText()
	   throws java.lang.IllegalArgumentException,
	          javax.swing.text.BadLocationException
	{
	    int lines = jTextArea.getLineCount();
	    for (int i=0; i <= lines; i++)
	    {
	       int end = jTextArea.getLineEndOffset(i);
	       jTextArea.replaceRange("", 0, end);
	    }
	}
	//}}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == jEdit)
				jEdit_actionPerformed(event);
			else if (object == jCancel)
				jCancel_actionPerformed(event);
			else if (object == jReparse)
				jReparse_actionPerformed(event);
			else if (object == jCont)
				jCont_actionPerformed(event);
		}
	}

 /**
 * Allow the user to edit the Spice file.
 *
 * @param event unused.
 */

	void jEdit_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		s2iProperties.loadDefaultProperties(true);
		String editCmd = s2iProperties.getEditorCommand();
		if (editFileName != null)
		   editCmd += (" " + editFileName);
		try {
		    Runtime.getRuntime().exec(editCmd);
		}
		catch(java.io.IOException ioe)
		{
		    s2iError.PrintMsg(ioe.toString(), s2iError.ERR, s2iError.LOG |
		                        s2iError.DISPLAY, this);
		    String Msg = "Unable to edit SPICE File";
		    s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.LOG |
		                        s2iError.DISPLAY, this);
		}
	}

 /**
 * Abandon the Spice file and close the window.
 *
 * @param event unused.
 */

	void jCancel_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		setVisible(false); // hide the Frame
		dispose();	     // free the system resources
		cmdValue = "CANCEL";
	}

 /**
 * Check the Spice file and show audit warnings.
 *
 * @param event unused.
 */

	void jReparse_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		setVisible(false); // hide the Frame
		dispose();	     // free the system resources
		cmdValue = "PARSE";
	}

 /**
 * Move on the the s2iProjectSetup window.
 *
 * @param event unused.
 */

	void jCont_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		setVisible(false); // hide the Frame
		dispose();	     // free the system resources
		cmdValue = "CONTINUE";
	}
}
