/*
 *
 * Copyright 1999, Cadence Design Systems, Incorporated.
 *
 * Cadence Design Systems (Cadence) and the author hereby disclaim
 * all implied warranties, including the implied warranties of merchant-
 * ability and fitness for a particular purpose. Cadence is not liable for
 * any damages incurred by the use of this software and/or documentation,
 * including direct, indirect, special, incidental, or consequential
 * damages.
 *
 * Cadence grants the bearer the right to modify, copy, and redistribute
 * this software and documentation, but requests that Cadence be acknowledged
 * for its contribution in the resulting product.
 *
 */

import javax.swing.*;
import java.awt.*;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.FileFilter;
import java.io.IOException;
import javax.swing.JFrame;
import javax.swing.event.TableModelEvent;
import javax.swing.DefaultListSelectionModel;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;
import javax.swing.JPanel;
import javax.swing.JEditorPane;
import javax.swing.DefaultCellEditor;

/**
 * The SpiTran main class.
 *
 * @author Anish Malhotra, Cadence Design Systems
 */
public class s2iMain extends javax.swing.JFrame implements s2iDBOpenListener
{
/**
 * Construct the SpiTran main class.
 */
	public s2iMain()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setTitle("SpiTran: SPICE to IBIS Transalator");
		getContentPane().setLayout(new BorderLayout(0,0));
		setVisible(false);
		setSize(544,361);
		setBackground(new Color(12632256));
		jToolBar1 = new javax.swing.JToolBar();
		jToolBar1.setMargin(new java.awt.Insets(0,0,0,0));
		jToolBar1.setBounds(0,0,544,4);
		jToolBar1.setFont(new Font("Dialog", Font.PLAIN, 12));
		jToolBar1.setForeground(new Color(0));
		getContentPane().add("North", jToolBar1);
		jPanel1 = new javax.swing.JPanel();
		GridBagLayout gridBagLayout;
		gridBagLayout = new GridBagLayout();
		jPanel1.setLayout(gridBagLayout);
		jPanel1.setBounds(0,4,544,357);
		jPanel1.setFont(new Font("Dialog", Font.PLAIN, 12));
		jPanel1.setForeground(new Color(0));
		getContentPane().add("Center", jPanel1);
		jLabel1 = new javax.swing.JLabel();
		jLabel1.setText("Available Subcircuits:");
		jLabel1.setToolTipText("List of subcircuits defined in the SPICE file");
		jLabel1.setBounds(10,10,131,23);
		jLabel1.setFont(new Font("Dialog", Font.PLAIN, 12));
		jLabel1.setForeground(new Color(0));
		GridBagConstraints gbc;
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(10,10,0,0);
		gbc.ipadx = 5;
		gbc.ipady = 8;
		((GridBagLayout)jPanel1.getLayout()).setConstraints(jLabel1, gbc);
		jPanel1.add(jLabel1);
		jScrollPane1 = new javax.swing.JScrollPane();
		jScrollPane1.setOpaque(true);
		jScrollPane1.setBounds(0,33,544,125);
		jScrollPane1.setFont(new Font("Dialog", Font.PLAIN, 12));
		jScrollPane1.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.gridwidth = 2;
		gbc.weightx = 1.0;
		gbc.weighty = 0.5;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jPanel1.getLayout()).setConstraints(jScrollPane1, gbc);
		jPanel1.add(jScrollPane1);
		jTable1 = new javax.swing.JTable();
		jTable1.setSelectionForeground(new java.awt.Color(16777215));
		jTable1.setSelectionBackground(new java.awt.Color(-16777056));
		jTable1.setToolTipText("List of subcircuits defined in the SPICE file");
		jTable1.setBounds(0,0,544,123);
		jTable1.setFont(new Font("Dialog", Font.PLAIN, 12));
		jTable1.setForeground(new Color(0));
		jTable1.setBackground(new Color(16777215));
		jScrollPane1.getViewport().add(jTable1);
		jLabel2 = new javax.swing.JLabel();
		jLabel2.setRequestFocusEnabled(false);
		jLabel2.setText("Instantiated Subcircuits:");
		jLabel2.setToolTipText("Edit Node cells to define connectivity between nodes.");
		jLabel2.setBounds(10,173,131,15);
		jLabel2.setFont(new Font("Dialog", Font.PLAIN, 12));
		jLabel2.setForeground(new Color(0));
		jLabel2.setBackground(new Color(-3355444));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 2;
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(10,10,0,0);
		((GridBagLayout)jPanel1.getLayout()).setConstraints(jLabel2, gbc);
		jPanel1.add(jLabel2);
		jButton1 = new javax.swing.JButton();
		jButton1.setText("      Instantiate      ");
		jButton1.setActionCommand("Instantiate");
		jButton1.setToolTipText("Instantiates subcircuits selected in the table above.");
		jButton1.setBounds(407,158,127,25);
		jButton1.setFont(new Font("Dialog", Font.PLAIN, 12));
		jButton1.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 1;
		gbc.gridy = 2;
		gbc.anchor = GridBagConstraints.EAST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(0,0,10,10);
		((GridBagLayout)jPanel1.getLayout()).setConstraints(jButton1, gbc);
		jPanel1.add(jButton1);
		jScrollPane2 = new javax.swing.JScrollPane();
		jScrollPane2.setOpaque(true);
		jScrollPane2.setBounds(2,195,540,125);
		jScrollPane2.setFont(new Font("Dialog", Font.PLAIN, 12));
		jScrollPane2.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 3;
		gbc.gridwidth = 2;
		gbc.weightx = 1.0;
		gbc.weighty = 0.5;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(2,2,2,2);
		((GridBagLayout)jPanel1.getLayout()).setConstraints(jScrollPane2, gbc);
		jPanel1.add(jScrollPane2);
		jTable2 = new javax.swing.JTable();
		jTable2.setSelectionForeground(new java.awt.Color(16777215));
		jTable2.setSelectionBackground(new java.awt.Color(-16777056));
		jTable2.setCellSelectionEnabled(true);
		jTable2.setColumnSelectionAllowed(false);
		jTable2.setRowSelectionAllowed(false);
		jTable2.setSelectionMode(javax.swing.DefaultListSelectionModel.SINGLE_SELECTION);
		jTable2.setToolTipText("Edit Node cells to define connectivity between nodes.");
		jTable2.setBounds(0,0,544,127);
		jTable2.setFont(new Font("Dialog", Font.PLAIN, 12));
		jTable2.setForeground(new Color(0));
		jTable2.setBackground(new Color(16777215));
		DefaultCellEditor cellEdit = new DefaultCellEditor(new JTextField());
		cellEdit.setClickCountToStart(1);
		jTable2.setCellEditor(cellEdit);
		jScrollPane2.getViewport().add(jTable2);
		jConfigButton = new javax.swing.JButton();
		jConfigButton.setText("Configure Nets ...");
		jConfigButton.setActionCommand("Configure Nets ...");
		jConfigButton.setToolTipText("Configure the nets which have been used to define connectivity.");
		jConfigButton.setBounds(405,322,129,25);
		jConfigButton.setFont(new Font("Dialog", Font.PLAIN, 12));
		jConfigButton.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 1;
		gbc.gridy = 4;
		gbc.anchor = GridBagConstraints.EAST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(0,0,10,10);
		((GridBagLayout)jPanel1.getLayout()).setConstraints(jConfigButton, gbc);
		jPanel1.add(jConfigButton);
		//}}

		//{{Non-symantec INIT_CONTROLS - anish 19th Jan 99
		// Add items to the toolbar
		TBIconNew = new javax.swing.JButton(
          new ImageIcon(s2iGlobals.getImageDir() + java.io.File.separator +
          "new.gif"));
		TBIconNew.setToolTipText("Create New Project");
		jToolBar1.add(TBIconNew);
		TBIconOpen = new javax.swing.JButton(
          new ImageIcon(s2iGlobals.getImageDir() + java.io.File.separator +
          "open.gif"));
		TBIconOpen.setToolTipText("Open Existing Project");
		jToolBar1.add(TBIconOpen);
		TBIconSave = new javax.swing.JButton(
          new ImageIcon(s2iGlobals.getImageDir() + java.io.File.separator +
          "save.gif"));
		TBIconSave.setToolTipText("Save Project");
		jToolBar1.add(TBIconSave);

		// Create and build menubar
		   {
		   menuBar = new javax.swing.JMenuBar();
		   javax.swing.JMenu menu;
		   javax.swing.JMenuItem menuItem;
		   setJMenuBar(menuBar);
		   menu = new javax.swing.JMenu("File");
		   menuItem_FileNew = new javax.swing.JMenuItem("New...");
		   menu.add(menuItem_FileNew);
		   menuItem_FileOpen = new javax.swing.JMenuItem("Open...");
		   menu.add(menuItem_FileOpen);
		   menuItem_FileSave = new javax.swing.JMenuItem("Save");
		   menu.add(menuItem_FileSave);
		   menuItem_FileExit = new javax.swing.JMenuItem("Exit");
		   menu.add(menuItem_FileExit);
		   menuBar.add(menu);
		   menu = new javax.swing.JMenu("Edit");
		   menuItem_EditSetup = new javax.swing.JMenuItem("Setup...");
		   menu.add(menuItem_EditSetup);
		   menuBar.add(menu);
		   menu = new javax.swing.JMenu("Translate");
		   menuItem_TranslateOptions = new javax.swing.JMenuItem("Options...");
		   menu.add(menuItem_TranslateOptions);
		   menuItem_TranslateExecute = new javax.swing.JMenuItem("Execute...");
		   menu.add(menuItem_TranslateExecute);
		   menuBar.add(menu);
		   menu = new javax.swing.JMenu("Help");
		   menuBar.add(menu);
		   menuItem_HelpUserGuide = new javax.swing.JMenuItem("User Guide...");
           menu.add(menuItem_HelpUserGuide);
		   menuItem_HelpAbout = new javax.swing.JMenuItem("About SpiTran...");
           menu.add(menuItem_HelpAbout);
		   }
		   
		// Initiate the sub-circuits with the Action of the button
		subcktInstantiator = new s2iCktInstantiator(jTable1, jTable2, jButton1);
		
		//Add the subcircuits from the SPICE file to the Table UI.
		  {
		     readSubCkts();
		  }
		
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		jConfigButton.addActionListener(lSymAction);
		TBIconNew.addActionListener(lSymAction);
		TBIconOpen.addActionListener(lSymAction);
		TBIconSave.addActionListener(lSymAction);
		//}}
		
		//{{ Non-Symantec REGISTER_LISTENERS
		menuItemListener amenuItemListener = new menuItemListener();
		menuItem_EditSetup.addActionListener(amenuItemListener);
		menuItem_FileNew.addActionListener(amenuItemListener);
		menuItem_FileOpen.addActionListener(amenuItemListener);
		menuItem_FileSave.addActionListener(amenuItemListener);
		menuItem_FileExit.addActionListener(amenuItemListener);
		menuItem_TranslateExecute.addActionListener(amenuItemListener);
		menuItem_TranslateOptions.addActionListener(amenuItemListener);
		menuItem_HelpUserGuide.addActionListener(amenuItemListener);
		menuItem_HelpAbout.addActionListener(amenuItemListener);
		//}}
	}

/**
 * Construct the SpiTran main class with a specific window title.
 * @param sTitle The window title String
 */
	public s2iMain(String sTitle)
	{
		this();
		setTitle(sTitle);
	}

/**
 * Construct the SpiTran main class with a specific window title.
 * @param b true if the window should become visible
 */
	public void setVisible(boolean b)
	{
		if (b)
			setLocation(50, 50);
		super.setVisible(b);
		/* Non-symantec code
		 * Get the values from the DB; and register as DB open listener
		 * Stay DB open listener till this form is alive
		 */
		if (b)
		{
		   getDB();
		   s2iDBReadWrite.addDBOpenListener(this);
		}
		else
		{
		   s2iDBReadWrite.removeDBOpenListener(this);
		}
	}

/**
 * Run SpiTran. This sets up a look and feel: <UL>
 * <LI>Windows look and feel is used on Windows
 * <LI>Motif look and feel is used on all others
 * </UL>
 * @param args This class can be run with arguments:
 *    -debug            Turn on verbose message printing
 *    -root <path>      Set the installation root if it is not the working dir
 */
	static public void main(String args[])
	{
	    //{{ Non-symantec code
		String os = System.getProperty("os.name");
		try {
		   if (os.equals("Windows NT"))
		   {
		      /* Get the Windows Look and Feel -anish 18Nov 98*/
		      UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		   }
		   else
		   {
		      /* Get the Motif Look and Feel -anish 12Nov 98*/
		      UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
		   }
		} catch (UnsupportedLookAndFeelException  exc1) {
		   System.err.println(exc1);
		} catch (Exception exc2) {
		   System.err.println(exc2);
		   System.err.println("Could not load LookAndFeel");
		}
		//}}

        // Process command line arguments
        int i = 0;
        while(i < args.length)
        {
           if(args[i].equals("-debug"))
           {
             // Turn on verbose message printing
             System.setProperty("DEBUG", "true");
           }
           else if(args[i].equals("-root"))
           {
             // Set the SpiTranRoot variable so that SpiTran does not have to
             // be run from the installation root. This is handy for running
             // it in a debugger, where it is probably being run from the
             // java source directory.
             if(++i < args.length)
               s2iGlobals.SpiTranRoot = args[i];
             else
               System.err.println("ERROR: -root option requires path argument");
           }
           ++i;
        }

        // Open the log file
        try
        {
          s2iError.openNewLog();
        }
        catch(Exception e)
        {
          System.out.println(e.getMessage());
          System.out.println("No log file for this session");
        }

		(new s2iMain()).setVisible(true);
	}

/**
 * Call the superclass addNotify method, then adjust the layout.
 */
	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;
		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
/**
 * Has the layout been adjusted?
 */
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JToolBar jToolBar1;
	javax.swing.JButton TBIconNew;
	javax.swing.JButton TBIconOpen;
	javax.swing.JButton TBIconSave;
	javax.swing.JPanel jPanel1;
	javax.swing.JLabel jLabel1;
	javax.swing.JScrollPane jScrollPane1;
	javax.swing.JTable jTable1;
	javax.swing.JLabel jLabel2;
	javax.swing.JButton jButton1;
	javax.swing.JScrollPane jScrollPane2;
	javax.swing.JTable jTable2;
	javax.swing.JButton jConfigButton;
	//}}

	//{{Non-symantec CONTROLS anish 19th Jan 99
/** The menubar */
	javax.swing.JMenuBar menuBar;
/** The s2iCktInstantiator for manipulating the instance table */
	s2iCktInstantiator subcktInstantiator;
/** The Edit -> Setup menu command */
	javax.swing.JMenuItem menuItem_EditSetup;
/** The File -> New menu command */
	javax.swing.JMenuItem menuItem_FileNew;
/** The File -> Open menu command */
	javax.swing.JMenuItem menuItem_FileOpen;
/** The File -> Save menu command */
	javax.swing.JMenuItem menuItem_FileSave;
/** The File -> Exit menu command */
	javax.swing.JMenuItem menuItem_FileExit;
/** The Translate -> Options menu command */
	javax.swing.JMenuItem menuItem_TranslateOptions;
/** The Translate -> Execute menu command */
	javax.swing.JMenuItem menuItem_TranslateExecute;
/** The "Configure Nodes" window */
	s2iConfigureNodes s2iConfigureNodes1;
/** The Help -> User Guide menu command */
	javax.swing.JMenuItem menuItem_HelpUserGuide;
/** The Help -> About menu command */
	javax.swing.JMenuItem menuItem_HelpAbout;
	//}}

	//{{DECLARE_MENUS
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == s2iMain.this)
				JFrame1_WindowClosing(event);
		}
	}

/**
 * Quit the application when the main window closes.
 * @param event unused
 */
	void JFrame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false); // hide the Frame
		dispose();	     // free the system resources
		System.exit(0);    // close the application
	}

/**
 * A class to handle menu events.
 */
	class menuItemListener implements java.awt.event.ActionListener{
/**
 * Handle a menu event.
 * @param ev The event that triggered the call
 */
   public void actionPerformed(java.awt.event.ActionEvent ev)
   {
      Object object = ev.getSource();
			if (object == menuItem_EditSetup)
			{
			    (new s2iProjectSetup(s2iMain.this, false)).setVisible(true);
			}
			else if(object == menuItem_FileNew)
			{
			    (new s2iNewProject(s2iMain.this)).setVisible(true);
			}
			else if(object == menuItem_FileOpen)
			{
			    FileOpen();
			}
			else if(object == menuItem_FileSave)
			{
			    // Archive the Instantiated sub-circuits.
                            s2iGlobals.gInstanceVector =
                            ((s2iInstCktTableModel) jTable2.getModel()).archive();
			    s2iDBReadWrite.writeDBtoFile();
			}
			else if (object == menuItem_FileExit)
			{
			    (new s2iQuitDialog(s2iMain.this, true)).setVisible(true);
			}
			else if(object == menuItem_TranslateExecute)
			{
			    TranslateExecute();
			}
			else if(object == menuItem_TranslateOptions)
			{
        	    (new s2iTransOptions(s2iMain.this)).setVisible(true);
			}
			else if(object == menuItem_HelpUserGuide)
			{
        	    showHelp();
			}
			else if(object == menuItem_HelpAbout)
			{
        	    showAbout();
			}
		}
	}

/**
 * A class to handle button and field events.
 */
	class SymAction implements java.awt.event.ActionListener
	{
/**
 * Handle a button or field event.
 * @param event The event that triggered the call
 */
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == jConfigButton)
				jButton2_actionPerformed(event);
			else if(object == TBIconNew)
			{
			    (new s2iNewProject(s2iMain.this)).setVisible(true);
			}
			else if(object == TBIconOpen)
			{
			    FileOpen();
			}
			else if(object == TBIconSave)
			{
			    // Archive the Instantiated sub-circuits.
                s2iGlobals.gInstanceVector = ((s2iInstCktTableModel) jTable2.getModel()).archive();
			    s2iDBReadWrite.writeDBtoFile();
			}
		}
	}

/**
 * Handle an action event on the Configure Nodes button.
 * @param event The event that triggered the call
 */
	void jButton2_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		java.util.Enumeration uniqueNodeNames = ((s2iInstCktTableModel) jTable2.getModel()).getNodes();
		String nodeName;

		//{{CONNECTION
		// Create and show as modal
		{
			s2iConfigureNodes1 = new s2iConfigureNodes(uniqueNodeNames);
			s2iConfigureNodes1.setModal(true);
			s2iConfigureNodes1.show();
		}
		//}}
	}
	
/**
 * Read in subckt definitions from the Spice file and display them in the
 * subckt definition table.
 */
	void readSubCkts()
	{
		s2iSubCktTableModel PreModCktTableModel = new s2iSubCktTableModel();
		java.util.Enumeration subCkts;
		try{
		    subCkts = s2iSpiceReader.getSubcktDefs(s2iGlobals.ProjDirFile +
		              java.io.File.separator + s2iGlobals.spiceFileName);
		    while (subCkts.hasMoreElements())
	        {
		        PreModCktTableModel.addCktDef((String) subCkts.nextElement());
		    }
		    jTable1.setModel(PreModCktTableModel);
		}
		catch(java.io.FileNotFoundException ex) {}
		catch (java.io.IOException ex) {}

		// Specify the Model for the Instantiator Table
		s2iInstCktTableModel InstanceTableModel = new s2iInstCktTableModel();
		jTable2.setModel(InstanceTableModel);

	}

/**
 * Write items to a new Spice file:
 *<UL>
 * <LI>A list of Strings provided in the call
 * <LI>A list of .LIB file names provided in the call
 *</UL>
 * @param fname The name String of the file to write
 * @param prefix The Vector of strings to begin the file with
 * @param vect The Vector of .LIB file names to append
 * @exception java.io.IOException
 * @exception java.lang.IndexOutOfBoundsException
 */
	void writeLibnInclToFile(String fname, String prefix[], java.util.Vector vect)
               throws java.io.IOException, java.lang.IndexOutOfBoundsException
	{
            java.io.File outFile = new java.io.File(fname);
            // We'll overwrite this File
            if (outFile.exists())
               outFile.delete();
            //Create the file for output
            BufferedWriter outFileWriter = new BufferedWriter(new FileWriter(outFile));

            // Copy the strings provided by the caller
            if (prefix != null)
            {
               int len = prefix.length;
               for (int i=0; i<len; i++)
               {
                 outFileWriter.write(prefix[i] + "\n");
               }
            }

            // The elements to be written will be available in list
            int size = vect.size();
            for (int i =0 ; i< size; i++)
            {
              String LibNameWEntry = (String) vect.elementAt(i);
              outFileWriter.write(s2iGlobals.KWS_LIB + " " + LibNameWEntry + "\n");
            }
            outFileWriter.close();

	}

/**
 * Prepare all of the files needed by s2ibis and run it
 */
 void TranslateExecute()
	{
            /*******************************************************
             * It's time to prepare Files for typ/min/max Library  *
             * references. Their names to be picked from  SpiTran  *
             * globals. These files are to have:                   *
             *   1. include statements for Ckt instantiation and   *
             *      source element files which are generated on    *
             *      Translate->Execute                             *
             *   2. Write in the LIBS/INCLUDES statements. If not- *
             *      thing in Best/Worst, simply copy the Typ data. *
             *******************************************************/
             if (s2iGlobals.ProjDirFile != null)
             {
                try{
                    String name;
                    String includes[] = new String[2];
                    //ckt instantiation fileName
                    includes[0] = s2iGlobals.KWS_INCLUDE + " " +
                                  s2iGlobals.XFileNamePrefix + s2iGlobals.spiceFileName;
                                  
                    //Typical
                    name = s2iGlobals.ProjDirFile + java.io.File.separator
                           + s2iGlobals.TypModelFileName;
                    includes[1] = s2iGlobals.KWS_INCLUDE + " " + 
                                  s2iGlobals.confTypFileNamePfx + s2iGlobals.spiceFileName;
                    writeLibnInclToFile(name, includes, s2iGlobals.gTypModelTreeList);
                    
                    //Best
                    name = s2iGlobals.ProjDirFile + java.io.File.separator
                           + s2iGlobals.MaxModelFileName;
                    includes[1] = s2iGlobals.KWS_INCLUDE + " " +
                                  s2iGlobals.confMaxFileNamePfx + s2iGlobals.spiceFileName;
                    if (s2iGlobals.gBestModelTreeList.isEmpty())
                    {
                        writeLibnInclToFile(name, includes, s2iGlobals.gTypModelTreeList);
                    }
                    else
                    {
                        writeLibnInclToFile(name, includes, s2iGlobals.gBestModelTreeList);
                    }
                    
                    //Worst
                    includes[1] = s2iGlobals.KWS_INCLUDE + " " + 
                                  s2iGlobals.confMinFileNamePfx + s2iGlobals.spiceFileName;
                    name = s2iGlobals.ProjDirFile + java.io.File.separator
                           + s2iGlobals.MinModelFileName;
                    if (s2iGlobals.gWorstModelTreeList.isEmpty())
                    {
                        writeLibnInclToFile(name, includes, s2iGlobals.gTypModelTreeList);
                    }
                    else
                    {
                        writeLibnInclToFile(name, includes, s2iGlobals.gWorstModelTreeList);
                    }
                    
                } catch( java.lang.Exception ex)
                {
                  s2iError.PrintMsg(ex.toString(), s2iError.ERR, s2iError.DISPLAY | 
                                      s2iError.LOG, this);
                }
             }

	    /*********************************************************
	     * This will write out SPICE statements corresponding to *
	     * the subcircuit instantiations and node configuration  *
	     * Then, s2ibis2 (another exe) will be invoked. Finally,*
	     * process_ibs will do the post processing of the gener- *
	     * ated IBIS file.
	     ********************************************************/    
	     
	     //Open the file for writing the instantiation statements
	     BufferedWriter out = null;
	     try
	     {
	        out = new BufferedWriter(new FileWriter (s2iGlobals.ProjDirFile +
	              java.io.File.separator + s2iGlobals.XFileNamePrefix + 
	              s2iGlobals.spiceFileName));
	     }
	     catch (java.io.IOException ioe)
	     {
	        String Msg = ioe.getMessage();
	        s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.LOG |
	                    s2iError.DISPLAY | s2iError.POPUP, this);
	     }
	     
	     
	     //Output the circuit instantiation statements
	     s2iInstCktTableModel instTableModel = (s2iInstCktTableModel) jTable2.getModel();
	     int nrow = instTableModel.getRowCount();
	     int ncol = instTableModel.getColumnCount();
	     StringBuffer instance = new StringBuffer();
	     Object value;
	     for (int row_ctr = 0; row_ctr < nrow ; row_ctr++)
	     {
	        instance.setLength(0);
	        for (int col_ctr = 0; col_ctr < ncol ; col_ctr++)
	        {
	            value = instTableModel.getValueAt(row_ctr, col_ctr);
	            if (value != null)
	            {
	                if (col_ctr == 1) instance.append("X");
	                if (col_ctr != 0)
	                {
	                   instance.append((String) value);
	                   instance.append("  ");
	                }
	            }
	        }
	        value = instTableModel.getValueAt(row_ctr, 0);
	        if (value != null)
	        {
	            instance.append((String) value);
	        }
	        s2iError.Debug(instance.toString());
	        try
	        {
	            out.write(instance.toString());
	            out.newLine();
	        }
	        catch (java.io.IOException ioe)
	        {
	            String Msg = ioe.getMessage();
	            s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.LOG |
	                        s2iError.DISPLAY | s2iError.POPUP, this);
	        }
	     }
	     try
	     {
	        out.close();
	     }
	     catch (java.io.IOException ioe)
	     {
	        String Msg = ioe.getMessage();
	        s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.LOG |
	                    s2iError.DISPLAY | s2iError.POPUP, this);
	     }
	     
	     
	     // Read in the relevant data of the SPICE file, the instantiation
	     // statements and Open the output file for configuration statements.
	     s2iSpiceData spiceData = new s2iSpiceData(((new StringBuffer()).append(
	                 s2iGlobals.ProjDirFile).append(java.io.File.separator).
	                 append(s2iGlobals.spiceFileName)).toString());
	     try
	     {
	        spiceData.fillData();
	     }
	     catch(java.io.FileNotFoundException fnfe)
	     {
	        String Msg = fnfe.getMessage();
	        s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.LOG |
	                    s2iError.DISPLAY | s2iError.POPUP, this);
	     }
	     catch(java.io.IOException ioe)
	     {
	        String Msg = ioe.getMessage();
	        s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.LOG |
	                    s2iError.DISPLAY | s2iError.POPUP, this);
	     }
	        
	     BufferedWriter outTyp = null, outMin = null, outMax = null;
	     try
	     {
	        outTyp = new BufferedWriter(new FileWriter (s2iGlobals.ProjDirFile
	                 + java.io.File.separator + s2iGlobals.confTypFileNamePfx + 
	                 s2iGlobals.spiceFileName));
	        outMin = new BufferedWriter(new FileWriter (s2iGlobals.ProjDirFile
	                 + java.io.File.separator + s2iGlobals.confMinFileNamePfx + 
	                 s2iGlobals.spiceFileName));
	        outMax = new BufferedWriter(new FileWriter (s2iGlobals.ProjDirFile
	                 + java.io.File.separator + s2iGlobals.confMaxFileNamePfx + 
	                 s2iGlobals.spiceFileName));
	     }
	     catch (java.io.IOException ioe)
	     {
	        String Msg = ioe.getMessage();
	        s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.LOG |
	                    s2iError.DISPLAY | s2iError.POPUP, this);
	        return;
	     }
	     
	     /*  Output the node/net configuration statements
	        ================================================
	        - For each row in the table, look at the 2nd column
	          (Pin Type). If it's float then output the statement
	          to fix these nodes to the specified voltage through
	          the specified resistance
	     */
	     s2iConfigTableModel cTableModel = (s2iConfigTableModel) s2iConfigureNodes1.getConfigTable().getModel();
	     String pinType, res, vTyp, vMin, vMax, node, vElem, rElem, dummyNode;
	     String vStmnt, rStmnt;
	     nrow = cTableModel.getRowCount();
	     for (int i=0; i<nrow; i++)
	     {
	        pinType = cTableModel.getPinType(i);
	        if ((pinType != null) && (pinType.trim().compareTo("Float") == 0))
	        {
	            res = cTableModel.getResistance(i);
	            vTyp = cTableModel.getTypVoltage(i);
	            vMin = cTableModel.getMinVoltage(i);
	            vMax = cTableModel.getMaxVoltage(i);
	            node = cTableModel.getNode(i);
	            rElem = spiceData.getUniqueResElemName();
	            vElem = spiceData.getUniqueVoltElemName();
	            dummyNode = spiceData.getUniqueNodeName();
	            rStmnt = rElem + "  " + node + "  " + dummyNode + "  " + res;
	            vStmnt = vElem + "  " + dummyNode + "  0  ";  
	            try
	            {
	               outTyp.write(vStmnt + vTyp);
	               outTyp.newLine();
	               outTyp.write(rStmnt);
	               outTyp.newLine(); outTyp.newLine();
	               
	               outMin.write(vStmnt + vMin);
	               outMin.newLine();
	               outMin.write(rStmnt);
	               outMin.newLine(); outMin.newLine();
	               
	               outMax.write(vStmnt + vMax);
	               outMax.newLine();
	               outMax.write(rStmnt);
	               outMax.newLine(); outMax.newLine();
	            }
	            catch (java.io.IOException ioe)
	            {
	               String Msg = ioe.getMessage();
	               s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.LOG |
	                           s2iError.DISPLAY | s2iError.POPUP, this);
	            }
	        }
	     } //End for
	     try
	     {
	        outTyp.close();
	        outMin.close();
	        outMax.close();
	     }
	     catch (java.io.IOException ioe)
	     {
	         String Msg = ioe.getMessage();
	         s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.LOG |
	                     s2iError.DISPLAY | s2iError.POPUP, this);
	     }

	     /* *******************************************
	     *  Generation of the s2i command file and IBIS file names.
	     *********************************************/
	     s2iProperties.loadDefaultProperties(true);
         String rootDir = s2iGlobals.getRootDir();
         String projDir = s2iGlobals.ProjDirFile.getPath();
	     int baseNmEnd = s2iGlobals.spiceFileName.lastIndexOf(".");
	     if (baseNmEnd == -1)
	        baseNmEnd = s2iGlobals.spiceFileName.length();
	     String baseFileName = s2iGlobals.spiceFileName.substring(0, baseNmEnd);
	     String s2iCmdFileName = baseFileName + s2iGlobals.S2I_CMD_FILE_EXTN;
         String ibisFileName = projDir + java.io.File.separator +
            baseFileName + s2iGlobals.IBIS_FILE_EXTN;

	     /* *******************************************
	     * Commands for s2ibis2 and post processing.  *
	     *********************************************/
         try {
           String os = System.getProperty("os.name");
           String script = os.startsWith("Windows") ? "spitran.bat" : "spitran.csh";

           // Form the command for running s2ibis. It will look like:
           // spitran.bat -root C:\spitran -s2ibis C:\proj\buff buff.s2i buff.ibs
           String s2ibisCmd =
             s2iGlobals.getRootDir() + java.io.File.separator + script +
             " -root " + projDir +
             " -s2ibis " + projDir + " " + s2iCmdFileName + " " + ibisFileName;

           // Create a text window for show command output
	       s2iRunStatus runDisplayer = new s2iRunStatus();
           runDisplayer.setModal(false);
           runDisplayer.setVisible(true);
	       runDisplayer.addText(s2ibisCmd);
           int endPos = runDisplayer.getTextArea().getDocument().getEndPosition().getOffset();
           runDisplayer.getTextArea().setCaretPosition(endPos-1);

           // Run the command in a new thread so that the runDisplayer can
           // show the output incrementally. Nice idea, but for some reason
           // all of the output is displayed at the end anyway.
           String[] cmd = new String[1];
           cmd[0] = s2ibisCmd;
           Thread batThread = new Thread(new s2iProcess(cmd, runDisplayer.getTextArea()));
           batThread.start();
         }
         catch(Exception e)
         {
           System.out.println(e);
         }
	}

/**
 * Allow the user to choose a SpiTran project file, and open it.
 */
	void FileOpen()
	{
       String ProjFileName = null;
	   JFileChooser importBrowser = new JFileChooser(".");
   	   importBrowser.setApproveButtonText(" Open ");
	   importBrowser.setDialogTitle("Open SpiTran Project");
	   importBrowser.setFileFilter(new sppFilter());
	   int retVal = importBrowser.showOpenDialog(this);
	   if (retVal == JFileChooser.APPROVE_OPTION)
	   {
	      java.io.File selection = importBrowser.getSelectedFile();
	      try
	      {
	         ProjFileName = selection.getCanonicalPath();
	      }
	      catch(java.io.IOException ioe)
	      {
	         ProjFileName = selection.getAbsolutePath();
	      }
	      s2iDBReadWrite.readDBfromFile(ProjFileName);
	   }
	}

/**
 * Display the information read in from a SpiTran project file.
 */
	public void getDB()
	{
	   s2iSubCktTableModel.clearAll();
	   ((s2iInstCktTableModel) jTable2.getModel()).clearAll();
	   readSubCkts();
	   int size = s2iGlobals.gInstanceVector.size();
	   for (int i =0 ; i< size; i++)
	   {
	      ((s2iInstCktTableModel) jTable2.getModel()).addInstance
	          ((String) s2iGlobals.gInstanceVector.elementAt(i));
	   }
	   jTable1.tableChanged(new TableModelEvent(jTable1.getModel(), TableModelEvent.HEADER_ROW) );
	   jTable2.tableChanged(new TableModelEvent(jTable2.getModel(), TableModelEvent.HEADER_ROW) );
           // ((s2iInstCktTableModel) jTable2.getModel()).printdataNcol();
	   java.util.Enumeration uniqueNodeNames = ((s2iInstCktTableModel) jTable2.getModel()).getNodes();
	   s2iConfigureNodes1 = new s2iConfigureNodes(uniqueNodeNames);
	}

/**
 * A FileFilter class for choosing SpiTran project files in a JFileChooser
 */
  class sppFilter extends javax.swing.filechooser.FileFilter
  {
/**
 * Get the description String for SpiTran project files in a JFileChooser
 */
    public String getDescription()
    {
      return("SpiTran Project File");
    }

/**
 * Determine if a file entry should be shown in a JFileChooser. Only SpiTran
 * Project Files and directories are shown.
 * @param f The file to accept or reject
 * @return true if the file should be shown
 */
    public boolean accept(java.io.File f)
    {
      return (f.isDirectory() ||
             (f.isFile()&& f.canRead() && f.getPath().endsWith(".spp")));
    }
  }

/**
 * Show the User Guide. There should be a version of this that takes a keyword
 * for context-sensitive help. This method is static so that it can be called
 * from other classes without the instance variable.
 */
  public static void showHelp()
  {
    try
    {
      String os = System.getProperty("os.name");
      String cmd = s2iGlobals.getRootDir() + java.io.File.separator + "spitran.csh";
      if(os.startsWith("Windows"))
        cmd = s2iGlobals.getRootDir() + java.io.File.separator + "spitran.bat";

      Runtime.getRuntime().exec(
        cmd + " -root " + s2iGlobals.getRootDir() + " -help");
    }
    catch(Exception e)
    {
      System.out.println(e.getMessage());
    }
  }

  public void showAbout()
  {
    String msg = "SpiTran " + s2iGlobals.VERSION +
      " SPICE to IBIS translation tool";
    s2iError.PrintMsg(msg, s2iError.INFO, s2iError.POPUP, null);
  }
}

