/*
 *
 * Copyright 1999, Cadence Design Systems, Incorporated.
 *
 * Cadence Design Systems (Cadence) and the author hereby disclaim
 * all implied warranties, including the implied warranties of merchant-
 * ability and fitness for a particular purpose. Cadence is not liable for
 * any damages incurred by the use of this software and/or documentation,
 * including direct, indirect, special, incidental, or consequential
 * damages.
 *
 * Cadence grants the bearer the right to modify, copy, and redistribute
 * this software and documentation, but requests that Cadence be acknowledged
 * for its contribution in the resulting product.
 *
 */


import javax.swing.table.AbstractTableModel;
import java.util.StringTokenizer;

public class s2iSubCktTableModel extends AbstractTableModel{
private static Object[][] data = new Object[50][];
private static String[] colNames;
private static int rowCtr = 0;
private static int maxCol = 0;

public static void clearAll()
{
   data = new Object[50][];
   rowCtr = 0;
   maxCol = 0;
}

public int getColumnCount() 
{
   return maxCol;
}

public int getRowCount() 
{
   return rowCtr;
}

public String getColumnName(int col)
{
   //return colNames[col];
  String name;

  switch(col){
    case 0  : name = new String("SUBCKT");
              break;
    default : name = new String("Node " + (new Integer(col)).toString());
              break;
  }
  return name;
}

public Object getValueAt(int row, int col)
{
   return data[row][col];
}

public void addCktDef(String CktDef)
{
   int colCtr = 0;
   String cktName = null;
   Object[] Row = new Object[100];

   if (CktDef == null) return;
   StringTokenizer st = new StringTokenizer(CktDef);
   String Token = null;
   if (st.hasMoreTokens())
   {
      Token = st.nextToken();
      cktName = Token;
      Row[colCtr++] = Token;
   }
   while (st.hasMoreTokens())
   {
      Token = st.nextToken();
      // Words with an '=' are parameters, not terminals
      if(Token.indexOf('=') < 0)
        Row[colCtr++] = Token;
   }
   if (maxCol < colCtr) maxCol = colCtr;

   // If the Definition had at least one token then increment the rows in data
   if (cktName!= null) 
      data[rowCtr++] = Row;
}   

public void printdataNcol()
{
   int row, col;
   row =0; col = 0;
   String msg = "";

   // Print the colomn Names
   while (col < maxCol)
      msg.concat("\t" + getColumnName(col++));
   msg.concat("\n");
   // Print the data
   while (row < rowCtr)
   {
      col = 0;
      msg.concat("\nRow " + row +": ");
      while (col < maxCol)
         msg.concat("\t" +data[row][col++]);
      row++;
   }
   s2iError.Debug(msg);
}

/* This will add a few dummy circuits and then print out data and colNames */
public static void main(String[] arg)
{

  s2iSubCktTableModel PreModCktTableModel = new s2iSubCktTableModel();

  PreModCktTableModel.addCktDef("CKT1 VCC GND PIN POUT");
  PreModCktTableModel.addCktDef("CKT2 N1 N2 N3 N4 N5");
  PreModCktTableModel.addCktDef("CKT3 Node1 Node2");

  PreModCktTableModel.printdataNcol();
  return ;
}

}
